
/*************************************************************
  project: <type project name here>
  author: <type your name here>
  description: <type what this file does>
*************************************************************/

//#include "arduino.h"
#include "types.h"
#include "global_data.h"
#include "Menu_types.h"
#include "Interupts.h"
#include "Inputs.h"
#include "Logic.h"
#include "Outputs.h"
#include <PinChangeInterrupt.h>
#include <PinChangeInterruptBoards.h>
#include <PinChangeInterruptPins.h>
#include <PinChangeInterruptSettings.h>


// event interuppt handlers


bool HB_Event_Pending = false;
bool HB_Active = false;

bool STARTER_Event_Pending = false;
bool STARTER_Active = false;

bool LEFT_Event_Pending = false;
bool LEFT_Active = false;

bool RIGHT_Event_Pending = false;
bool RIGHT_Active = false;

bool HORN_Event_Pending = false;
bool HORN_Active = false;

bool KILL_Event_Pending = false;
bool KILL_Active = false;

bool BRAKES_Event_Pending = false;
bool BRAKES_Active = false;

bool LIGHTS_Event_Pending = false;
bool LIGHTS_Active = false;

bool GATE_Event_Pending = false;
bool GATE_Active = false;


void Clear_Start_Interrupts(void)
{  
  HB_Event_Pending = false;
  STARTER_Event_Pending = false;
  LEFT_Event_Pending = false;
  RIGHT_Event_Pending = false; 
  HORN_Event_Pending = false;
  KILL_Event_Pending = false;
  BRAKES_Event_Pending = false;
  LIGHTS_Event_Pending = false;
  GATE_Event_Pending = false;

  HB_Active = Get_Start_State(INPUT_PIN_HIGH_BEAM_SW, CONFIG_PARAM_HIGH_POL); 
  LIGHTS_IN = Get_Start_State(INPUT_PIN_LIGHTS_SW, CONFIG_PARAM_LIGHTS_POL); 
  STARTER_Active = Get_Start_State(INPUT_PIN_STARTER_SW, CONFIG_PARAM_STARTER_POL);
  LEFT_Active =  Get_Start_State(INPUT_PIN_LEFT_SW, CONFIG_PARAM_LEFT_POL);
  RIGHT_Active =  Get_Start_State(INPUT_PIN_RIGHT_SW, CONFIG_PARAM_RIGHT_POL);
  HORN_Active = Get_Start_State (INPUT_PIN_HORN_SW, CONFIG_PARAM_HORN_POL);
  BRAKES_Active = Get_Start_State(INPUT_PIN_BRAKE_SW, CONFIG_PARAM_BRAKE_POL);
  KILL_Active = Get_Start_State(INPUT_PIN_KILL_SW, CONFIG_PARAM_KILL_POL);  
  GATE_Active = Get_Start_State(INPUT_PIN_GATE_SW, CONFIG_PARAM_GATE_POL);
}


// data-----------------------------------------------------

// possibly need to set up some mapping functions for the inoput to state conversion.
//not filtering any events as will need the lenght of button presses so need to know all edges

bool Get_Event_Status(uint8_t TRIG, uint8_t POL, uint8_t MODE)
{
  if (TRIG == RISING)
  {
    if (TheConfigEpromData.Values[POL].Bool == true)   // true high is active, false low is active
    {        
      if (TheConfigEpromData.Values[MODE].Bool == true)  // mode true = STATE false = press
        return (true); // active high, state
      else
        return (true);  // active high, momentary
    }
    else
    {
      if (TheConfigEpromData.Values[MODE].Bool == true)  // mode true = STATE false = press
        return (true); // active low, state
      else
        return (true);// active low momentary
    }
  }
  else if (TRIG == FALLING)
  {
    if (TheConfigEpromData.Values[POL].Bool == true)   // true high is active, false low is active
    {        
      if (TheConfigEpromData.Values[MODE].Bool == true)  // mode true = STATE false = press
        return (true); // active high, state
      else
        return (true);  // active high, momentary
    }
    else
    {
      if (TheConfigEpromData.Values[MODE].Bool == true)  // mode true = STATE false = press
        return (true); // active low, state
      else
        return (true);// active low momentary
    }
  }
  else
    return(false);
}


bool Get_Active_Status(uint8_t TRIG, uint8_t POL, uint8_t MODE)
{
  if (TRIG == RISING)
  {
    if (TheConfigEpromData.Values[POL].Bool == true)   // true high is active, false low is active
    {        
      if (TheConfigEpromData.Values[MODE].Bool == true)  // mode true = STATE false = press
        return (true); // active high, state
      else
        return (true); // active high, momentary
    }
    else
    {
      if (TheConfigEpromData.Values[MODE].Bool == true)  // mode true = STATE false = press
        return (false); // active low, state
      else
        return (false);// active low momentary
    }
  }
  else if (TRIG == FALLING)
  {
    if (TheConfigEpromData.Values[POL].Bool == true)   // true high is active, false low is active
    {        
      if (TheConfigEpromData.Values[MODE].Bool == true)  // mode true = STATE false = press
        return (false); // active high, state
      else
        return (false);  // active high, momentary
    }
    else
    {
      if (TheConfigEpromData.Values[MODE].Bool == true)  // mode true = STATE false = press
        return (true); // active low, state
      else
        return (true);// active low momentary
    }
  }
  else
    return(false);
}



void Int_HIGH_BEAM(void)
{
  uint8_t trigger;

  trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_HIGH_BEAM_SW));

  HB_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_HIGH_POL, CONFIG_PARAM_HIGH_MODE);
  HB_Active = Get_Active_Status(trigger, CONFIG_PARAM_HIGH_POL, CONFIG_PARAM_HIGH_MODE);
}


void Int_STARTER(void)
{
  uint8_t trigger;

  trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_STARTER_SW));

  STARTER_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_STARTER_POL, CONFIG_PARAM_STARTER_MODE);
  STARTER_Active = Get_Active_Status(trigger, CONFIG_PARAM_STARTER_POL, CONFIG_PARAM_STARTER_MODE);
}


void Int_LEFT(void)
{
  uint8_t trigger;

  trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_LEFT_SW));

  LEFT_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_LEFT_POL, CONFIG_PARAM_LEFT_MODE);
  LEFT_Active = Get_Active_Status(trigger, CONFIG_PARAM_LEFT_POL, CONFIG_PARAM_LEFT_MODE);
}


void Int_RIGHT(void)
{
  uint8_t trigger;

  trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_RIGHT_SW));

  RIGHT_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_RIGHT_POL, CONFIG_PARAM_RIGHT_MODE);
  RIGHT_Active = Get_Active_Status(trigger, CONFIG_PARAM_RIGHT_POL, CONFIG_PARAM_RIGHT_MODE);
}


void Int_HORN(void)
{
  uint8_t trigger;

  trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_HORN_SW));
  
  HORN_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_HORN_POL, CONFIG_PARAM_HORN_MODE);
  HORN_Active = Get_Active_Status(trigger, CONFIG_PARAM_HORN_POL, CONFIG_PARAM_HORN_MODE);
}


void Int_KILL(void)
{
  uint8_t trigger;

  trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_KILL_SW));
  
  KILL_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_KILL_POL, CONFIG_PARAM_KILL_MODE);
  KILL_Active = Get_Active_Status(trigger, CONFIG_PARAM_KILL_POL, CONFIG_PARAM_KILL_MODE);
}


void Int_BRAKE(void)
{
  uint8_t trigger;

  trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_BRAKE_SW));

  BRAKES_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_BRAKE_POL, CONFIG_PARAM_BRAKE_MODE);
  BRAKES_Active = Get_Active_Status(trigger, CONFIG_PARAM_BRAKE_POL, CONFIG_PARAM_BRAKE_MODE);
}


void Int_LIGHTS(void)
{
  uint8_t trigger;

  trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_LIGHTS_SW));
  
  LIGHTS_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_LIGHTS_POL, CONFIG_PARAM_LIGHTS_MODE);
  LIGHTS_Active = Get_Active_Status(trigger, CONFIG_PARAM_LIGHTS_POL, CONFIG_PARAM_LIGHTS_MODE);
}



uint16_t Int_GATE(uint16_t this_val, uint16_t last_val)
{
  uint16_t diff_val;
  uint8_t trigger;

  //trigger = getPinChangeInterruptTrigger(digitalPinToPCINT(INPUT_PIN_GATE_SW));
  // here we get the value  for the trigger
  diff_val = (this_val >= last_val) ? this_val - last_val : last_val - this_val;
  if (diff_val >= 512) // ie change of state
  {
     trigger = (this_val > 512) ? RISING : FALLING;  // set the trigger polarity
     last_val = this_val; // update chagned val
     GATE_Event_Pending = Get_Event_Status(trigger, CONFIG_PARAM_GATE_POL, CONFIG_PARAM_GATE_MODE);
     GATE_Active = Get_Active_Status(trigger, CONFIG_PARAM_GATE_POL, CONFIG_PARAM_GATE_MODE);
  }
  else
  {
      ;    
  }
  return (last_val);  
}


void Setup_Input_Pins(void)
{
  // configure the pins
 pinMode (INPUT_PIN_HIGH_BEAM_SW, INPUT); 
 pinMode (INPUT_PIN_STARTER_SW, INPUT);   
 pinMode (INPUT_PIN_LEFT_SW, INPUT);        
 pinMode (INPUT_PIN_RIGHT_SW, INPUT);      
 pinMode (INPUT_PIN_HORN_SW, INPUT);       
 pinMode (INPUT_PIN_KILL_SW, INPUT);      
 pinMode (INPUT_PIN_BRAKE_SW, INPUT);        
 pinMode (INPUT_PIN_LIGHTS_SW, INPUT);    
 //pinMode ( INPUT_PIN_GATE_SW, INPUT);          // ADC7
        
  // attach the interrupt routines
 attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_HIGH_BEAM_SW), Int_HIGH_BEAM, CHANGE);
 attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_STARTER_SW), Int_STARTER, CHANGE); 
 attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_LEFT_SW), Int_LEFT, CHANGE);       
 attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_RIGHT_SW), Int_RIGHT, CHANGE);    
 attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_HORN_SW), Int_HORN, CHANGE);    
 attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_KILL_SW), Int_KILL, CHANGE);     
 attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_BRAKE_SW), Int_BRAKE, CHANGE);        
 attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_LIGHTS_SW), Int_LIGHTS, CHANGE);    
 //attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(INPUT_PIN_GATE_SW), Int_GATE, CHANGE);      // polled as cant do interrupt change on this pin 
}


bool Get_Start_State(uint8_t PIN, uint8_t POL)
{
   bool input;
   input = digitalRead(PIN);
   
#ifdef  STATE_TRACE_ON 
   Serial.print(F("PIN-> "));
   Serial.print(PIN,DEC);
   Serial.print(F("  INDEX-> "));    
   Serial.print(POL,DEC); 
   Serial.print(F("  POLARITY-> "));    
   Serial.print(TheConfigEpromData.Values[POL].Bool ,DEC);    
   Serial.print(F("  INPUT-> "));    
   Serial.print(input,DEC);     
   Serial.print(F("  RTN-> "));   
#endif     
  
    if (TheConfigEpromData.Values[POL].Bool == input)
    {
#ifdef  STATE_TRACE_ON       
      Serial.println(1,DEC);
#endif          
      return (true);
    }      
   else
   {
#ifdef  STATE_TRACE_ON  
      Serial.println(0,DEC);   
#endif            
      return (false);
   }      

   // return (OUTPUT_ON);
}


